package org.tekkotsu.ui.editor.actions;

import org.eclipse.gef.EditDomain;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.GraphicalViewer;
import org.eclipse.gef.commands.CommandStack;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.jface.action.Action;
import org.tekkotsu.ui.editor.StateMachineEditor;
import org.tekkotsu.ui.editor.model.SourceNodeModel;

public class CreateNodeAction extends Action {
	private StateMachineEditor editor;
	private SourceNodeModel model;
	private CreateRequest request;

	public CreateNodeAction(StateMachineEditor editor, SourceNodeModel model) {
		super(model.getId(), AS_CHECK_BOX);
		this.editor = editor;
		this.model = model;
		request = new CreateRequest();
	}

	public SourceNodeModel getModel() {
		return model;
	}

	public CreateRequest getRequest() {
		return request;
	}

	@Override
	public void run() {
		EditDomain domain = editor.getEditDomain();
		CommandStack stack = domain.getCommandStack();
		GraphicalViewer view = editor.getGraphicalViewer();
		request.setFactory(model.getFactory());
		stack.execute(view.getContents().getEditPolicy(
				EditPolicy.LAYOUT_ROLE).getCommand(request));
		editor.setDirty();
	}
}
